<?php
class console_event_trigger_goodssync{

    
    /**
     *
     * 商品同步通知创建发起方法
     * @param string $wms_id 仓库类型ID
     * @param array $data 商品同步数据信息
     * @param string $sync 是否同步请求，true为同步，false异步，默认异步
     */
    public function create($wms_id, &$data, $sync = false){
        $db = kernel::database();
        $limit = 1000;
        $count = ceil(count($data)/$limit);
        for ($page=1;$page<=$count;$page++){
            $lim = ($page-1)*$limit;
            
            $params = array();
            $bns = array();
            for ($key=$lim;$key<$lim+$limit;$key++){
                
                if (!isset($data[$key])) break;
                $bns[] = '\''.$data[$key]['bn'].'\'';
                $params[] = $data[$key];
            }
            
            if ($params){
                //如果是自有仓储,直接更新成功
                $selfwms_list = kernel::single('console_goodssync')->get_wms_list('selfwms');
                
                if (in_array($wms_id,$selfwms_list)){
                    $new_tag = '1';
                    $sync_status = '3';
                    
                    $result = kernel::single('console_foreignsku')->batch_syncupdate($wms_id,$new_tag,$sync_status,$bns);
                }else{
                    $new_tag = '1';
                    $sync_status = '2';
                    $result = kernel::single('console_foreignsku')->batch_syncupdate($wms_id,$new_tag,$sync_status,$bns);
                }

                // $rs = kernel::single('middleware_wms_request', $wms_id)->goods_add($params,$sync);
                $rs = kernel::single('erpapi_router_request')->set('wms',$wms_id)->goods_add($params);

                unset($params);
               
            }
        }

        
    }

    /**
     *
     * 采购通知创建发起的响应接收方法
     * @param array $data
     */
    public function create_callback($res){

    }

    /**
     *
     * 商品同步通知更新发起方法
     * @param string $wms_id 仓库类型ID
     * @param array $data 商品同步数据信息
     * @param string $sync 是否同步请求，true为同步，false异步，默认异步
     */
    public function update($wms_id, &$data, $sync = false){
        $limit = 1000;
        $count = ceil(count($data)/$limit);
        ksort($data);
        for ($page=1;$page<=$count;$page++){
            $lim = ($page-1)*$limit;
            $params = array();
            $bns = array();
            for ($key=$lim;$key<$lim+$limit;$key++){
                if (!isset($data[$key])) break;
                $bns[] = '\''.$data[$key]['bn'].'\'';
                $params[] = $data[$key];
            }
            if ($params){
                
                

                //如果第三方仓储返回成功,则更新商品同步状态为已同步
                $selfwms_list = kernel::single('console_goodssync')->get_wms_list('selfwms');
               
                if (in_array($wms_id,$selfwms_list)){
                    $new_tag = '1';
                    $sync_status = '3';
                    kernel::single('console_foreignsku')->batch_syncupdate($wms_id,$new_tag,$sync_status,$bns);
                }else{
                    $new_tag = '1';
                    $sync_status = '2';
                    kernel::single('console_foreignsku')->batch_syncupdate($wms_id,$new_tag,$sync_status,$bns);
                }
                // $rs = kernel::single('middleware_wms_request', $wms_id)->goods_update($data,$sync);
                $rs = kernel::single('erpapi_router_request')->set('wms',$wms_id)->goods_update($data);

                unset($params);
            }
        }
        return true;
    }

    /**
     *
     * 商品通知更新发起的响应接收方法
     * @param array $data
     */
    public function update_callback($res){
        
    }

    public function syncCombination($id, $branchId) {
        $material = app::get('console')->model('foreign_sku')->db_dump(array('inner_product_id'=>$id,'inner_type'=>'1'));
        if(empty($material)) {
            return array('rsp'=>'fail', 'msg' => $id . '：数据缺失，已经被删除');
        }

        if(empty($material['outer_sku'])) {
            return array('rsp'=>'fail', 'msg' => $material['inner_sku'] . '：还没有外部sku');
        }
        $items = app::get("material")->model('sales_material')->getList("*", array('sm_id'=>$material['inner_product_id']));
        if(empty($items)) {
            return array('rsp'=>'fail', 'msg' => $material['inner_sku'] . '：捆绑商品明细不存在');
        }
        $products = array();
        $productBn = array();
        foreach($items as $val) {
            $products[$val['product_id']] = $val;
            $productBn[] = $val['bn'];
        }
        $productMaterial = app::get('console')->model('foreign_sku')->getList('*', array('inner_sku'=>$productBn,'wms_id'=>$material['wms_id']));
        if(empty($productMaterial)) {
            $first = current($products);
            return array('rsp'=>'fail', 'msg' => $material['inner_sku'] . '：子商品' . $first['bn'] . '尚未获取外部sku');
        }
        $materialItems = array();
        foreach($productMaterial as $val) {
            if(empty($val['outer_sku'])) {
                return array('rsp'=>'fail', 'msg' => $material['inner_sku'] . '：子商品' . $val['inner_sku'] . '尚未获取外部sku');
            }
            $materialItems[] = array(
                'inner_sku' => $val['inner_sku'],
                'outer_sku' => $val['outer_sku'],
                'num' => $products[$val['inner_product_id']]['pkgnum']
            );
            if($products[$val['inner_product_id']]) {
                unset($products[$val['inner_product_id']]);
            } else {
                return array('rsp'=>'fail', 'msg' => $material['inner_sku'] . '：子商品' . $val['inner_sku'] . '需要重新分配');
            }
        }
        if($products) {
            $first = current($products);
            return array('rsp'=>'fail', 'msg' => $material['inner_sku'] . '：子商品' . $first['bn'] . '尚未获取外部sku');
        }
        $branch = app::get('ome')->model('branch')->db_dump(array('branch_id'=>$branchId),'branch_id, branch_bn');
        $sdf = array(
            'material' => $material,
            'material_items' => $materialItems,
            'branch' => $branch
        );
        return kernel::single('erpapi_router_request')->set('wms',$material['wms_id'])->goods_addCombination($sdf);
    }

    public function syncMap($id, $wmsId, $operateType) {
        $mapGoods = app::get('console')->model('map_goods')->db_dump(array('id'=>$id));
        $material = app::get('console')->model('foreign_sku')->db_dump(array('inner_sku'=>$mapGoods['shop_product_bn'], 'wms_id'=>$wmsId));

        if(empty($material)) {
            return array('rsp'=>'fail', 'msg' => $mapGoods['shop_product_bn'] . '：尚未分配，请先分配');
        }
        if(empty($material['outer_sku'])) {
            return array('rsp'=>'fail', 'msg' => $mapGoods['shop_product_bn'] . '：尚未同步，请先同步');
        }
        $shop = app::get('ome')->model('shop')->db_dump(array('shop_id' => $mapGoods['shop_id']));
        $sdf = array(
            'map_goods' => $mapGoods,
            'material' => $material,
            'shop' => $shop,
            'operate_type' => $operateType
        );
        return kernel::single('erpapi_router_request')->set('wms',$material['wms_id'])->goods_syncMap($sdf);
    }

}