<?php
/**
 * @author
 * @describe 京东仓储入库单
 */
class erpapi_wms_matrix_jd_request_stockin extends erpapi_wms_request_stockin
{
    protected $_stockin_pagination = false;


    protected function _getNextObjType($ioType) {
        return 'search_' . $ioType;
    }

    public function _format_stockin_create_params($sdf)
    {
        $params = parent::_format_stockin_create_params($sdf);
        $params['department_no'] = app::get('wmsmgr')->getConf('department_no_'.$this->__channelObj->wms['channel_id']);
        $params['supplier_bn'] = $sdf['supplier_id'] ? $sdf['supplier_bn'] : 'nosuppliercode';
        return $params;
    }

    protected function _format_stockin_search_params($sdf)
    {
        $params = parent::_format_stockin_search_params($sdf);
        $params['order_type'] = $this->transfer_stockin_type($sdf['iso_type']);
        $params['warehouse_code'] = $this->get_warehouse_code($this->__channelObj->wms['channel_id'],$sdf['branch_bn']);
        return $params;
    }


    /**
     * 数据处理
     * @param $rs
     * @return array
     */
    protected function _deal_search_result($rs){

        $resultData = array();
        $data       = json_decode($rs['data'], true);

        if($data) {
            // 定义临时变量
            $items    = array();
            $outer_sku= array();
            $sku_list = array();
            $itemList = json_decode($data['item'],true);

            foreach($itemList as $val) {
                $outer_sku[] = $val['product_bn'];
                $sku_list[$val['product_bn']] = array(
                    'product_bn'    => $val['product_bn'],
                    'num'           => $val['normal_num'],
                    'normal_num'    => $val['normal_num'],
                    'defective_num' => $val['defective_num'],
                );
            }
            // 当物流类型为沧海物流时-查询erp内部货品编码
            if($this->__channelObj->channel['addon']['wms_type'] == '1'){
                $res = app::get('console')->model('foreign_sku')->getList('inner_sku,outer_sku',array('outer_sku'=>$outer_sku));
                if($res){
                    foreach ($res as $val) {
                        if ($sku_list[$val['outer_sku']]) {
                            $sku_list[$val['outer_sku']]['product_bn'] = $val['inner_sku'];
                        }else{
                            $sku_list[$val['outer_sku']]['product_bn'] = '';
                        }
                    }
                }
            }
            // 进行数据处理
            $items = array_values($sku_list);

            $resultData['type']         = $data['type'];
            $resultData['status']       = $data['status'];
            $resultData['remark']       = $data['remark'];
            $resultData['stockin_bn']   = $data['stock_bn'];
            $resultData['operate_time'] = $data['operate_time'];
            $resultData['item']         = json_encode($items);
        }
        $rs['data'] = $resultData;
        return $rs;
    }
}
