<?php
/**
 * 销售物料关联的基础物料信息
 * @author xiayuanjun@shopex.cn
 * @version 1.0
 */
class material_extracolumn_salesmaterial_associatedmaterial extends desktop_extracolumn_abstract implements desktop_extracolumn_interface{

    protected $__pkey = 'sm_id';

    protected $__extra_column = 'colunm_associated_material';

    /**
     *
     * 获取销售物料关联的基础物料信息
     * @param $ids
     * @return array $tmp_array关联数据数组
     */
    public function associatedData($ids){
        //获取福袋类型的销售物料ids
        $mdl_ma_sa_ma = app::get('material')->model('sales_material');
        $rs_luckybag = $mdl_ma_sa_ma->getList("*",array("sm_id"=>$ids,"sales_material_type"=>"4"));
        if(!empty($rs_luckybag)){
            $arr_luckybag_sm_ids = array();
            foreach($rs_luckybag as $var_rs_lu){
                $arr_luckybag_sm_ids[] = $var_rs_lu["sm_id"];
            }
            //移除$ids中的福袋类型的销售物料的sm_id 另外获取
            foreach($ids as $key_sm_id => $var_sm_id){
                if(in_array($var_sm_id,$arr_luckybag_sm_ids)){
                    unset($ids[$key_sm_id]);
                }
            }
        }
        
        $salesBasicMaterialLib = kernel::single('material_sales_material');
        $salesBasicMaterialLists = $salesBasicMaterialLib->getBasicMBySalesMIds($ids);
        
        $tmp_array= array();
        foreach($salesBasicMaterialLists as $sm_id=>$basicMaterials){
            foreach($basicMaterials as $k =>$basicMaterial){
                if(isset($tmp_array[$sm_id])){
                    $tmp_array[$sm_id] .= "  |  ".$basicMaterial['material_name']."(".$basicMaterial['material_bn'].") x ".$basicMaterial['number'];
                }else{
                    $tmp_array[$sm_id] = $basicMaterial['material_name']."(".$basicMaterial['material_bn'].") x ".$basicMaterial['number'];
                }
            }
        }
        
        //获取福袋类型数据
        if(!empty($arr_luckybag_sm_ids)){
            $mdl_ma_lu_ru = app::get('material')->model('luckybag_rules');
            $rs_luckybag = $mdl_ma_lu_ru->getList("*",array("sm_id"=>$arr_luckybag_sm_ids));
            $rl_sm_id_lbr = array();
            $rl_sm_id_bm_id = array();
            $rl_sm_id_lbr_info = array();
            foreach($rs_luckybag as $var_lkb){
                $rl_sm_id_lbr[$var_lkb["sm_id"]][] = $var_lkb["lbr_id"];
                $rl_sm_id_bm_id[$var_lkb["sm_id"]][] = $var_lkb["bm_ids"];
                $rl_sm_id_lbr_info[$var_lkb["sm_id"]][] = $var_lkb;
            }
            foreach($arr_luckybag_sm_ids as $var_lsi){
                $lbr_count = count($rl_sm_id_lbr[$var_lsi]);
                $bm_id_count = 0;
                foreach($rl_sm_id_bm_id[$var_lsi] as $var_sibi){
                    $temp_sibi = explode(",", $var_sibi);
                    $bm_id_count = $bm_id_count + count($temp_sibi);
                }
                $luckybag_dec = $this->get_luckybag_dec($rl_sm_id_lbr_info[$var_lsi]);
                $tmp_array[$var_lsi] = '<div onmouseover="bindFinderColTip(event);" rel="'.$luckybag_dec.'">'.$lbr_count.'组/'.$bm_id_count.'个SKU随机送</div>';
            }
        }
        
        return $tmp_array;
    }
    
    private function get_luckybag_dec($lbr_info){
        $mdl_ma_ba_ma = app::get('material')->model('basic_material');
        $luckybag_dec = "<div style='text-align:left'>";
        $count_rule = count($lbr_info);
        $count = 1;
        foreach($lbr_info as $var_li){
            $luckybag_dec .= "<b>".$var_li["lbr_name"]."</b><br />";
            $bm_ids = explode(",",$var_li["bm_ids"]);
            $rs_bm_info = $mdl_ma_ba_ma->getList("material_name,material_bn",array("bm_id"=>$bm_ids));
            $bm_infos = array();
            foreach ($rs_bm_info as $var_bif){
                $bm_infos[] = $var_bif["material_name"]."(".$var_bif["material_bn"].")";
            }
            $luckybag_dec .= implode("<br />",$bm_infos)."<br />随机选".$var_li["sku_num"]."个sku，分别发".$var_li["send_num"]."件";
            if ($count < $count_rule){
                $luckybag_dec .= "<br /><br />";
            }
            $count++;
        }
        $luckybag_dec .= "</div>";
        return $luckybag_dec;
    }

}