<?php
/**
 * @author ykm 2017/1/13
 * @describe 订单种类二进制常量类
 */

class ome_order_bool_type {
    #是否是服务订单
    const __SERVICE_CODE        = 0x0001;
    #菜鸟自动流转订单
    const __CNAUTO_CODE         = 0x0002;

    #跨境订单
    const __INTERNAL_CODE       = 0x0008;

	 #当日达
    const __CNDANG_CODE         = 0x0010;
    #次日达
    const __CNCI_CODE           = 0x0020;
    #预计时效表达
    const __CNSHI_CODE          = 0x0040;
    #预约配送
    const __CNYUE_CODE          = 0x0080;
    #多日达
    const __CNDUO_CODE          = 0x0100;

    private $boolStatus = array(
        self::__SERVICE_CODE => array('identifier'=>'服', 'text'=>'服务订单', 'color'=>'green'),
        self::__CNAUTO_CODE => array('identifier'=>'菜', 'text'=>'菜鸟自动流转订单', 'color'=>'yellow'),
        self::__INTERNAL_CODE => array('identifier'=>'跨', 'text'=>'跨境订单', 'color'=>'red'),

        self::__CNDANG_CODE => array('identifier'=>'直', 'text'=>'菜鸟联盟当日达订单', 'color'=>'#938F5C'),
        self::__CNCI_CODE => array('identifier'=>'直', 'text'=>'菜鸟联盟次日达订单', 'color'=>'#938F5C'),
        self::__CNSHI_CODE => array('identifier'=>'直', 'text'=>'预计时效表达订单', 'color'=>'#938F5C'),
        self::__CNYUE_CODE => array('identifier'=>'直', 'text'=>'菜鸟联盟预约配送订单', 'color'=>'#938F5C'),
        self::__CNDUO_CODE => array('identifier'=>'直', 'text'=>'菜鸟联盟多日达订单', 'color'=>'#938F5C'),
    );


    public function getBoolTypeText($num = null) {
        if($num) {
            return (array) $this->boolStatus[$num];
        }
        return $this->boolStatus;
    }

    public function getBoolTypeIdentifier($boolType) {
        $str = '';
        foreach($this->boolStatus as $k => $val) {
            if($boolType & $k) {
                $str .= sprintf("<span class='tag-label' title='%s' style='background-color:%s;color:#000000;'>%s</span>", $val['text'], $val['color'], $val['identifier']);
            }
        }
        return $str;
    }

    public function isCnService($boolType) {
        if(($boolType & ome_order_bool_type::__CNDANG_CODE)
            || ($boolType & ome_order_bool_type::__CNCI_CODE)
            || ($boolType & ome_order_bool_type::__CNSHI_CODE)
            || ($boolType & ome_order_bool_type::__CNDUO_CODE)
            || ($boolType & ome_order_bool_type::__CNYUE_CODE)){
            return true;
        }
        return false;
    }
}