<?php

class openapi_data_original_salesmaterial{

    protected $_type = array(
        '1' => '普通',
        '2' => '促销',
        '3' => '赠品',
        '4' => '福袋',
    );

    public function getList($filter,$offset=0,$limit=40)
    {
        $basicMStockFreezeLib  = kernel::single('material_basic_material_stock_freeze');
        
        $basicMaterialBarcodeLib    = kernel::single('material_basic_material_barcode');
        $basicMaterialStockObj   = app::get('material')->model('basic_material_stock');
        $salesMaterialObj   = app::get('material')->model('sales_material');
        $salesMaterialExtObj   = app::get('material')->model('sales_material_ext');
        $salesMaterialLib   = kernel::single('material_sales_material');
        $salesMaterialShopFreezeObj   = app::get('material')->model('sales_material_shop_freeze');
        $lib_ma_ba_ma = kernel::single('material_basic_material');

        $goodscount = $salesMaterialObj->count($filter);
        $goodslist = $salesMaterialObj->getList('*',$filter,$offset,$limit);
        
        $list = array();
        $formatFilter=kernel::single('openapi_format_abstract');
        foreach ((array) $goodslist as $value) {
            $salesMaterialExtInfo = $salesMaterialExtObj->getList('unit,retail_price' ,array('sm_id'=>$value['sm_id']) ,0 ,1);
            $unit = $salesMaterialExtInfo[0]['unit'] ? $salesMaterialExtInfo[0]['unit'] : '';
            $retail_price = $salesMaterialExtInfo[0]['retail_price'] ? $salesMaterialExtInfo[0]['retail_price'] : '';

            $good = array(
                'sales_material_bn'    => $formatFilter->charFilter($value['sales_material_bn']),
                'sales_material_name'  => $formatFilter->charFilter($value['sales_material_name']),
                'unit'        => $formatFilter->charFilter($unit),
                'sales_material_type'       => $value['sales_material_type'],
                'sales_material_type_name' => $this->_type[$value['sales_material_type']],
                'retail_price'       => $retail_price,
                'shop_id'  => $value['shop_id'],
            );
            
            if($value['sales_material_type'] == 4){ //福袋
                $mdl_ma_sa_ma = app::get('material')->model('luckybag_rules');
                $rs_luckybag_info = $mdl_ma_sa_ma->getList("*",array("sm_id"=>$value['sm_id']));
                if(empty($rs_luckybag_info)){
                    continue;
                }
                foreach($rs_luckybag_info as $var_l_i){
                    $basic_materials = array();
                    $bm_ids_arr = explode(",", $var_l_i["bm_ids"]);
                    foreach($bm_ids_arr as $var_bm_id){
                        $rs_basic_ma_info = $lib_ma_ba_ma->getBasicMaterialExt($var_bm_id);
                        $storeInfo = $basicMaterialStockObj->getList('store,store_freeze' ,array('bm_id'=>$var_bm_id) ,0 ,1);
                        //根据仓库ID、基础物料ID获取该物料仓库级的预占
                        $storeInfo[0]['store_freeze'] = $basicMStockFreezeLib->getMaterialStockFreeze($var_bm_id);
                        $basic_materials[] = array(
                            "material_bn" => $formatFilter->charFilter($rs_basic_ma_info['material_bn']),
                            "material_name" => $formatFilter->charFilter($rs_basic_ma_info['material_name']),
                            "store" => $storeInfo[0]['store'],
                            "store_freeze" => $storeInfo[0]['store_freeze'],
                            "weight" => $rs_basic_ma_info['weight'],
                            "cost" => $rs_basic_ma_info['cost'],
                            "retail_price" => $rs_basic_ma_info['retail_price'],
                            "barcode" => $rs_basic_ma_info["barcode"]
                        );
                    }
                    $good["luckybag_rules"][] = array(
                        "lbr_id" => $var_l_i["lbr_id"],
                        "lbr_name" => $var_l_i["lbr_name"],
                        "sku_num" => $var_l_i["sku_num"],
                        "send_num" => $var_l_i["send_num"],
                        "price" => $var_l_i["price"],
                        "basic_materials" => $basic_materials,
                    );
                }
            }else{
                $basicMInfos = $salesMaterialLib->getBasicMBySalesMId($value['sm_id']);
                if($basicMInfos){
                    foreach($basicMInfos as $basicMInfo){
                        $barcode = $basicMaterialBarcodeLib->getBarcodeById($basicMInfo['bm_id']);
                        $storeInfo = $basicMaterialStockObj->getList('store,store_freeze' ,array('bm_id'=>$basicMInfo['bm_id']) ,0 ,1);
                        
                        //根据仓库ID、基础物料ID获取该物料仓库级的预占
                        $storeInfo[0]['store_freeze']    = $basicMStockFreezeLib->getMaterialStockFreeze($basicMInfo['bm_id']);
                        
                        $good['basic_materials'][] = array(
                                'material_bn'   => $formatFilter->charFilter($basicMInfo['material_bn']),
                                'material_name'   => $formatFilter->charFilter($basicMInfo['material_name']),
                                'store'        => $storeInfo[0]['store'],
                                'store_freeze' => $storeInfo[0]['store_freeze'],
                                'weight'       => $basicMInfo['weight'],
                                'cost'         => $basicMInfo['cost'],
                                'retail_price'        => $basicMInfo['retail_price'],
                                'barcode'      => $formatFilter->charFilter($barcode),
                        );
                    }
                }
            }
            
            $list[] = $good;
        }

        return array('list' => $list,'count' => (int) $goodscount);
    }

    /**
     * 销售物料新增检查
     * @param Array $params
     * @param String $err_msg
     * @return Array
     */
    private function _checkAddParams(&$params, &$err_msg){
        if(empty($params['sales_material_name']) || empty($params['sales_material_bn'])){
            $err_msg ="必填信息不能为空";
            return false;
        }

        $basicMaterialObj = app::get('material')->model('basic_material');
        $salesMaterialObj = app::get('material')->model('sales_material');
        $salesMaterialInfo = $salesMaterialObj->getList('sales_material_bn',array('sales_material_bn'=>$params['sales_material_bn']));
        if($salesMaterialInfo){
            $err_msg ="当前新增的物料编码已被使用，不能重复";
            return false;
        }

        $params['sales_material_bn_crc32'] = sprintf('%u',crc32($params['sales_material_bn']));

        if($params['sales_material_type'] == 4){ //福袋
            $result_check_format = $this->check_luckybag_content($params,$err_msg);
            if(!$result_check_format && $err_msg){
                return false;
            }
            $params["luckybag_arr"] = $result_check_format;
        }else{ //原有走的促销 普通 赠品
            if($params['sales_material_type'] == 2){
                if(!isset($params['at'])){
                    $err_msg ="促销物料请至少设置一个物料明细内容";
                    return false;
                }
                
                $basicM_bns = $tmp_at = $tmp_pr = array();
                foreach ($params['at'] as $bn => $val){
                    if (count($params['at']) == 1){
                        if ($val <2){
                            $err_msg ="只有一种物料时，数量必须大于1";
                            return false;
                        }
                    }else {
                        if ($val < 1){
                            $err_msg ="数量必须大于0";
                            return false;
                        }
                    }
                    $basicInfo = $basicMaterialObj->getList('bm_id', array('material_bn'=>$bn), 0, 1);
                    if(!$basicInfo){
                        $err_msg ="找不到关联的基础物料";
                        return false;
                    }else{
                        $tmp_at[$basicInfo[0]['bm_id']] = $val;
                        $basicM_bns[$bn] = $basicInfo[0]['bm_id'];
                    }
                }
                unset($params['at']);
                $params['at'] = $tmp_at;
                
                foreach ($params['pr'] as $bn => $val){
                    $tmp_rate +=$val;
                    $tmp_pr[$basicM_bns[$bn]] = $val;
                }
                unset($params['pr']);
                $params['pr'] = $tmp_pr;
                
                if($tmp_rate > 100){
                    $err_msg ="分摊销售价合计百分比:".$tmp_rate.",已超100%";
                    return false;
                }elseif($tmp_rate < 100){
                    $err_msg ="分摊销售价合计百分比:".$tmp_rate.",不足100%";
                    return false;
                }
            }else{
                if(isset($params['bind_bn'])){
                    $basicInfo = $basicMaterialObj->getList('bm_id', array('material_bn'=>$params['bind_bn']), 0, 1);
                    if(!$basicInfo){
                        $err_msg ="找不到关联的基础物料";
                        return false;
                    }else{
                        $params['bind_bm_id'] = $basicInfo[0]['bm_id'];
                    }
                }
            }
        }
        
        return true;
    }

    public function add($data,&$code,&$sub_msg){
        $result = array('rsp'=>'succ');

        if(!$this->_checkAddParams($data, $error_msg)){
            $result['rsp'] = 'fail';
            $result['msg'] = $error_msg;
            return $result;
        }

        $salesMaterialObj = app::get('material')->model('sales_material');
        $salesMaterialExtObj = app::get('material')->model('sales_material_ext');
        $salesMaterialShopFreezeObj = app::get('material')->model('sales_material_shop_freeze');
        $formatFilter=kernel::single('openapi_format_abstract');

        $shop_id = $data['shop_id'] ? $data['shop_id'] : '_ALL_';
        //保存物料主表信息
        $addData = array(
            'sales_material_name' => $formatFilter->charFilter($data['sales_material_name']),
            'sales_material_bn' => $formatFilter->charFilter($data['sales_material_bn']),
            'sales_material_bn_crc32' => $data['sales_material_bn_crc32'],
            'sales_material_type' => $data['sales_material_type'],
            'shop_id' => $shop_id,
            'create_time' => time(),
        );
        $is_save = $salesMaterialObj->save($addData);
        if($is_save){
            $is_bind = false;
            //如果有关联物料就做绑定操作
            $salesBasicMaterialObj = app::get('material')->model('sales_basic_material');
            //普通销售物料关联
            if(($data['sales_material_type'] == 1 || $data['sales_material_type'] == 3) && !empty($data['bind_bm_id'])){
                $addBindData = array(
                        'sm_id' => $addData['sm_id'],
                        'bm_id' => $data['bind_bm_id'],
                        'number' => 1,
                );
                $salesBasicMaterialObj->insert($addBindData);

                $is_bind = true;
            }elseif($data['sales_material_type'] == 2 && !empty($data['at'])){
            //促销销售物料关联
                foreach($data['at'] as $k=>$v){
                    $addBindData = array(
                        'sm_id' => $addData['sm_id'],
                        'bm_id' => $k,
                        'number' => $v,
                        'rate' => $data['pr'][$k],
                    );
                    $salesBasicMaterialObj->insert($addBindData);
                    $addBindData = null;
                }

                $is_bind = true;
            }elseif($data['sales_material_type'] == 4 && !empty($data['luckybag_arr'])){ //福袋
                $mdl_material_luckybag_rules = app::get('material')->model('luckybag_rules');
                foreach($data['luckybag_arr'] as $var_lbr){
                    $addBindData = array(
                            "lbr_name" => $var_lbr["lbr_name"],
                            "sm_id" => $addData['sm_id'],
                            "bm_ids" => implode(",", $var_lbr["bm_ids"]),
                            "sku_num" => $var_lbr["sku_num"],
                            "send_num" => $var_lbr["send_num"],
                            "price" => $var_lbr["price"],
                    );
                    $mdl_material_luckybag_rules->insert($addBindData);
                }
                $is_bind = true;
            }

            //如果有绑定物料数据，设定销售物料为绑定状态
            if($is_bind){
                $salesMaterialObj->update(array('is_bind'=>1),array('sm_id'=>$addData['sm_id']));
            }

            //保存销售物料扩展信息
            $addExtData = array(
                'sm_id' => $addData['sm_id'],
                'cost' => $data['cost'] ? $data['cost'] : 0.00,
                'retail_price' => $data['retail_price'] ? $data['retail_price'] : 0.00,
                'weight' => $data['weight'] ? $data['weight'] : 0.00,
                'unit' => $data['unit'],
            );
            $salesMaterialExtObj->insert($addExtData);
            
            //保存销售物料店铺级冻结
            if($shop_id != '_ALL_'){
                $addStockData = array(
                    'sm_id' => $addData['sm_id'],
                    'shop_id' => $shop_id,
                    'shop_freeze' => 0,
                );
                $salesMaterialShopFreezeObj->insert($addStockData);
            }
        }else{
            $result = array('msg'=>'销售物料添加失败', 'rsp'=>'fail');
        }

        return $result;
    }


    /**
     * 销售物料编辑时的参数检查方法
     * 
     * @param Array $params 
     * @param String $err_msg
     * @return Boolean
     */
    function checkEditParams(&$params, &$err_msg){

        if(empty($params['sales_material_name']) || empty($params['sales_material_bn'])){
            $err_msg ="必填信息不能为空";
            return false;
        }

        $basicMaterialObj = app::get('material')->model('basic_material');
        $salesMaterialObj = app::get('material')->model('sales_material');
        $salesMaterialExistInfo = $salesMaterialObj->getList('*',array('sales_material_bn'=>$params['sales_material_bn']));
        if(!$salesMaterialExistInfo){
            $err_msg ="当前物料不存在";
            return false;
        }else{
            $params['sm_id'] = $salesMaterialExistInfo[0]['sm_id'];
            $params['old_sm_info'] = $salesMaterialExistInfo[0];
        }
        
        if($params['sales_material_type'] == 4){ //福袋
            $result_check_format = $this->check_luckybag_content($params,$err_msg,true);
            if(!$result_check_format && $err_msg){
                return false;
            }
            $params["luckybag_arr"] = $result_check_format;
        }else{
            $basicM_bns = $tmp_at = $tmp_pr = array();
            if($params['sales_material_type'] == 2){
                if(!isset($params['at'])){
                    $err_msg ="组合物料请至少设置一个物料明细内容";
                    return false;
                }
                
                foreach ($params['at'] as $bn => $val){
                    if (count($params['at']) == 1){
                        if ($val <2){
                            $err_msg ="只有一种物料时，数量必须大于1";
                            return false;
                        }
                    }else {
                        if ($val < 1){
                            $err_msg ="数量必须大于0";
                            return false;
                        }
                    }
                    $basicInfo = $basicMaterialObj->getList('bm_id', array('material_bn'=>$bn), 0, 1);
                    if(!$basicInfo){
                        $err_msg ="找不到关联的基础物料";
                        return false;
                    }else{
                        $tmp_at[$basicInfo[0]['bm_id']] = $val;
                        $basicM_bns[$bn] = $basicInfo[0]['bm_id'];
                    }
                }
                unset($params['at']);
                $params['at'] = $tmp_at;
                
                foreach ($params['pr'] as $bn => $val){
                    $tmp_rate +=$val;
                    $tmp_pr[$basicM_bns[$bn]] = $val;
                }
                unset($params['pr']);
                $params['pr'] = $tmp_pr;
                
                if($tmp_rate > 100){
                    $err_msg ="分摊销售价合计百分比:".$tmp_rate.",已超100%";
                    return false;
                }elseif($tmp_rate < 100){
                    $err_msg ="分摊销售价合计百分比:".$tmp_rate.",不足100%";
                    return false;
                }
            }else{
                if(isset($params['bind_bn'])){
                    $basicInfo = $basicMaterialObj->getList('bm_id', array('material_bn'=>$params['bind_bn']), 0, 1);
                    if(!$basicInfo){
                        $err_msg ="找不到关联的基础物料";
                        return false;
                    }else{
                        $params['bind_bm_id'] = $basicInfo[0]['bm_id'];
                    }
                }
            }
        }

        return true;
    }

    /**
     * 检查基础物料个别参数是否可编辑
     * 
     * @param Int $bm_id
     * @return Array
     */
    function checkEditReadOnly($shop_id, $sm_id, $is_bind){
        $readonly = array('type' => false,'shop'=>false,'bind_item'=>false);

        //如果销售物料有冻结、订单，那么物料类型不能变
        if($shop_id != '_ALL_'){
            $shopFreezeObj = app::get('material')->model('sales_material_shop_freeze');
            $storeInfo = $shopFreezeObj->getList('shop_freeze',array('sm_id'=>$sm_id,'shop_id'=>$shop_id));
            if($storeInfo[0]['shop_freeze'] > 0){
                $is_type_readonly = true;
            }
        }

        $orderObjObj = app::get('ome')->model('order_objects');
        $orderInfo = $orderObjObj->getList('obj_id,goods_id',array('goods_id'=>$sm_id));
        if($orderInfo){
            $has_object = true;
            $is_type_readonly = true;
            $is_shop_readonly = true;
        }

        if($is_type_readonly){
            $readonly['type'] = true;
        }

        if($is_shop_readonly){
            $readonly['shop'] = true;
        }

        //已绑定有订单的不能变
        if($is_bind == 1 && $has_object == true){
            $orderItemObj = app::get('ome')->model('order_items');
            $orderItemInfo = $orderItemObj->db->select("select item_id from sdb_ome_order_items as oi left join sdb_ome_order_objects as oo on oi.obj_id = oo.obj_id where goods_id = ".$sm_id." LIMIT 0,1");
            if($orderItemInfo){
                $is_bind_item_readonly = true;
            }
        }

        if($is_bind_item_readonly){
            $readonly['bind_item'] = true;
        }

        return $readonly;
    }

    public function edit($data,&$code,&$sub_msg){
        $result = array('rsp'=>'succ');

        if(!$this->checkEditParams($data, $error_msg)){
            $result['rsp'] = 'fail';
            $result['msg'] = $error_msg;
            return $result;
        }

        $salesMaterialObj = app::get('material')->model('sales_material');
        $salesMaterialExtObj = app::get('material')->model('sales_material_ext');

        //检查物料是否有关联的订单,关联的基础物料不能改变
        $readonly = $this->checkEditReadOnly($data['old_sm_info']['shop_id'], $data['sm_id'], $data['old_sm_info']['is_bind']);
        $data['sales_material_type'] = $readonly['type'] ? $data['old_sm_info']['sales_material_type'] : $data['sales_material_type'];
        $data['shop_id'] = $readonly['shop'] ? $data['old_sm_info']['shop_id'] : '_ALL_';

        //更新基础物料基本信息
        $updateData['sales_material_name'] = $data['sales_material_name'];
        $updateData['sales_material_type'] = $data['sales_material_type'];
        $updateData['shop_id'] = $data['shop_id'];
        $filter['sm_id'] = $data['sm_id'];

        $is_update = $salesMaterialObj->update($updateData,$filter);
        if($is_update){
            $is_bind = false;
            //如果有关联物料就做绑定操作
            $salesBasicMaterialObj = app::get('material')->model('sales_basic_material');
            //删除原有关联基础物料信息
            $salesBasicMaterialObj->delete(array('sm_id'=>$filter['sm_id']));
            //目前如果编辑时sales_material_type不是4福袋 原销售物料时福袋 删除原有的福袋数据
            $mdl_material_luckybag_rules = app::get('material')->model('luckybag_rules');
            if($data['sales_material_type'] != 4){
                $rs_old_luckybag = $mdl_material_luckybag_rules->dump(array("sm_id"=>$filter['sm_id']));
                if(!empty($rs_old_luckybag)){ //有旧的福袋数据删除sm_id对应的所有lbr数据
                    $mdl_material_luckybag_rules->delete(array("sm_id"=>$filter['sm_id']));
                }
            }

            //普通销售物料关联
            if(($data['sales_material_type'] == 1 || $data['sales_material_type'] == 3) && (!$readonly['bind_item']) && !empty($data['bind_bm_id'])){
                $addBindData = array(
                        'sm_id' => $filter['sm_id'],
                        'bm_id' => $data['bind_bm_id'],
                        'number' => 1,
                );
                $salesBasicMaterialObj->insert($addBindData);

                $is_bind = true;
            }elseif($data['sales_material_type'] == 2 && (!$readonly['bind_item']) && !empty($data['at'])){
            //促销销售物料关联
                foreach($data['at'] as $k=>$v){
                    $addBindData = array(
                        'sm_id' => $filter['sm_id'],
                        'bm_id' => $k,
                        'number' => $v,
                        'rate' => $data['pr'][$k],
                    );
                    $salesBasicMaterialObj->insert($addBindData);
                    $addBindData = null;
                }

                $is_bind = true;
            }elseif($data['sales_material_type'] == 4 && !$readonly['bind_item'] && !empty($data['luckybag_arr'])){ //福袋
                //这里根据sm_id和lbr_name判断是否存在此组合 存在更新 不存在新增 多余的删除
                $rs_luckybag_list = $mdl_material_luckybag_rules->getList("lbr_id,lbr_name",array("sm_id"=>$filter['sm_id']));
                if(empty($rs_luckybag_list)){ //修改sales_material_type为4过来的 做新增
                    foreach($data['luckybag_arr'] as $var_lbr){
                        $addBindData = array(
                                "lbr_name" => $var_lbr["lbr_name"],
                                "sm_id" => $filter['sm_id'],
                                "bm_ids" => implode(",", $var_lbr["bm_ids"]),
                                "sku_num" => $var_lbr["sku_num"],
                                "send_num" => $var_lbr["send_num"],
                                "price" => $var_lbr["price"],
                        );
                        $mdl_material_luckybag_rules->insert($addBindData);
                    }
                }else{ //做更新
                    $lbr_name_arr = array();
                    foreach($data['luckybag_arr'] as $var_lbr){
                        $lbr_name_arr[] = $var_lbr["lbr_name"];
                    }
                    $del_lbr_id_arr = array();
                    foreach($rs_luckybag_list as $var_rll){
                        if(!in_array($var_rll["lbr_name"],$lbr_name_arr)){
                            $del_lbr_id_arr[] = $var_rll["lbr_id"];
                        }
                    }
                    if(!empty($del_lbr_id_arr)){
                        $mdl_material_luckybag_rules->delete(array("lbr_id"=>$del_lbr_id_arr));
                    }
                    foreach($data['luckybag_arr'] as $var_lbr_v2){
                        $filter_arr = array("lbr_name"=>$var_lbr_v2["lbr_name"],"sm_id"=>$filter['sm_id']);
                        $rs_lkb_info = $mdl_material_luckybag_rules->dump($filter_arr,"lbr_id");
                        if(empty($rs_lkb_info)){ //新增的
                            $addBindData = array(
                                    "lbr_name" => $var_lbr_v2["lbr_name"],
                                    "sm_id" => $filter['sm_id'],
                                    "bm_ids" => implode(",", $var_lbr_v2["bm_ids"]),
                                    "sku_num" => $var_lbr_v2["sku_num"],
                                    "send_num" => $var_lbr_v2["send_num"],
                                    "price" => $var_lbr_v2["price"],
                            );
                            $mdl_material_luckybag_rules->insert($addBindData);
                        }else{
                            $update_arr = array(
                                "bm_ids" => implode(",", $var_lbr_v2["bm_ids"]),
                                "sku_num" => $var_lbr_v2["sku_num"],
                                "send_num" => $var_lbr_v2["send_num"],
                                "price" => $var_lbr_v2["price"],
                            );
                            $mdl_material_luckybag_rules->update($update_arr,$filter_arr);
                        }
                    }
                }
                $is_bind = true;
            }
            
            if($readonly['bind_item']){ //如果该销售物料有订单的
                $is_bind = true;
            }

            //如果有绑定物料数据或者有订单的，设定销售物料为绑定状态
            if($is_bind){
                $salesMaterialObj->update(array('is_bind'=>1),array('sm_id'=>$filter['sm_id']));
            }else{
                $salesMaterialObj->update(array('is_bind'=>2),array('sm_id'=>$filter['sm_id']));
            }

            //更新销售物料扩展信息
            $updateExtData = array(
                'cost' => $data['cost'] ? $data['cost'] : 0.00,
                'retail_price' => $data['retail_price'] ? $data['retail_price'] : 0.00,
                'weight' => $data['weight'] ? $data['weight'] : 0.00,
                'unit' => $data['unit'],
            );
            $salesMaterialExtObj->update($updateExtData, $filter);
        }else{
            $result = array('msg'=>'销售物料更新失败', 'rsp'=>'fail');
        }

        return $result;
    }
    
    //检查填写的福袋组合信息格式内容
    private function check_luckybag_content($params,&$err_msg,$edit=false){
        if(!is_numeric($params["retail_price"]) || $params["retail_price"]< 0){
            $err_msg = "销售价必须是大于等于0的数字";return false;
        }
        $luckybag_bind_info = trim($params["luckybag_bind_info"]);
        if(!$luckybag_bind_info){
            $err_msg = "福袋类关联物料信息不能为空";return false;
        }
        $bm_ids_record = array();
        $return_luckybag_rules = array();
        $arr_lbr_name = array();
        $reg_number = "/^[1-9][0-9]*$/";
        $luckybag_total_price = 0;
        $basicMaterialObj = app::get('material')->model('basic_material');
        $tmp_luckybag_rules = explode('#', $luckybag_bind_info);
        foreach($tmp_luckybag_rules as $var_tlr){
            $current_bm_ids = array();
            $tmp_luckybag_name = explode(':', $var_tlr);
            if(count($tmp_luckybag_name) == 2){
                if(!$tmp_luckybag_name[0]){
                    $err_msg = "福袋组合名称异常";break;
                }
                if(!$tmp_luckybag_name[1]){
                    $err_msg = "福袋组合内容异常";break;
                }
                if(in_array($tmp_luckybag_name[0],$arr_lbr_name)){
                    $err_msg = "组合名称不能相同";break;
                }else{
                    $arr_lbr_name[] = $tmp_luckybag_name[0];
                }
                $tmp_luckybag_detail = explode('-', $tmp_luckybag_name[1]);
                if(count($tmp_luckybag_detail) == 2){
                    if(!$tmp_luckybag_detail[0]){
                        $err_msg = $tmp_luckybag_name[0]."：的福袋组合基础物料异常";break;
                    }
                    if(!$tmp_luckybag_detail[1]){
                        $err_msg = $tmp_luckybag_name[0]."：的福袋组合规则参数异常";break;
                    }
                    $luckybag_bm_bns = explode("|", $tmp_luckybag_detail[0]);
                    $rs_bm_ids = $basicMaterialObj->getList("bm_id",array("material_bn"=>$luckybag_bm_bns));
                    if(empty($rs_bm_ids)){
                        $err_msg = $tmp_luckybag_name[0]."：的福袋组合基础物料不存在";break;
                    }
                    if(count($rs_bm_ids) < count($luckybag_bm_bns)){
                        $err_msg = $tmp_luckybag_name[0]."：的福袋组合基础物料编码重复或不存在";break;
                    }
                    $luckybag_params = explode("|", $tmp_luckybag_detail[1]);
                    if(count($luckybag_params) != 3){
                        $err_msg = $tmp_luckybag_name[0]."：的福袋组合参数异常";break;
                    }
                    $duplicate_bm_id_flag = false;
                    foreach($rs_bm_ids as $var_bi){
                        if(in_array($var_bi["bm_id"],$bm_ids_record)){
                            $duplicate_bm_id_flag = true;break;
                        }else{
                            $current_bm_ids[] = $var_bi["bm_id"]; //当前组合
                            $bm_ids_record[] = $var_bi["bm_id"]; //所有组合
                        }
                    }
                    if($duplicate_bm_id_flag){
                        $err_msg = "所有组合中基础物料不得重复";break;
                    }
                    if(!preg_match($reg_number,$luckybag_params[0])){
                        $err_msg = $tmp_luckybag_name[0]."：sku数必须是大于0的整数";break;
                    }
                    if(!preg_match($reg_number,$luckybag_params[1])){
                        $err_msg = $tmp_luckybag_name[0]."：送件数必须是大于0的整数";break;
                    }
                    if($luckybag_params[0] > count($current_bm_ids)){
                        $err_msg = $tmp_luckybag_name[0]."：sku数不得大于当前基础物料sku数量";break;
                    }
                    if(!is_numeric($luckybag_params[2]) || $luckybag_params[2] < 0){
                        $err_msg = $tmp_luckybag_name[0]."：单品售价必须是大于等于0的数字";break;
                    }
                    $luckybag_total_price = $luckybag_total_price + ($luckybag_params[0]*$luckybag_params[1]*$luckybag_params[2]);
                    //当前组合检查完成赋值
                    $return_luckybag_rules[] = array(
                        "lbr_name" => $tmp_luckybag_name[0],
                        "bm_ids" => $current_bm_ids,
                        "sku_num" => $luckybag_params[0],
                        "send_num" => $luckybag_params[1],
                        "price" => $luckybag_params[2],
                    );
                }else{
                    $err_msg = $tmp_luckybag_name[0]."格式错误";break;
                }
            }else{
                $err_msg = "福袋类关联物料信息错误";break;
            }
        }
        
        if($err_msg){
            return false;
        }else{
            if($params["retail_price"] != $luckybag_total_price){
                $err_msg = "售价和组合总和售价必须相等";return false;
            }
            $filter_luckybag_exists = array("lbr_name"=>$arr_lbr_name);
            if($edit){ //编辑
                $filter_luckybag_exists["sm_id|noequal"] = $params['sm_id'];
            }
            $mdl_material_luckybag_rules = app::get('material')->model('luckybag_rules');
            $rs_lbr = $mdl_material_luckybag_rules->getList("lbr_name",$filter_luckybag_exists);
            if(!empty($rs_lbr)){
                $exist_lbr_names = array();
                foreach($rs_lbr as $var_r_l){
                    $exist_lbr_names[] = $var_r_l["lbr_name"];
                }
                $err_msg = "组合：".implode(",",$exist_lbr_names)."已经存在";return false;
            }
            return $return_luckybag_rules;
        }
        
    }
    
}